

#include <ESP8266WiFi.h>
#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#include "muMatrix8ptRegular.h"
#include "muHeavy8ptBold.h"
#include "functions_5.h"

#ifndef PSTR
 #define PSTR // Make Arduino Due happy
#endif

#define PIN 14
#define LED_BLACK    0

#define LED_RED_VERYLOW   (3 <<  11)
#define LED_RED_LOW     (7 <<  11)
#define LED_RED_MEDIUM    (15 << 11)
#define LED_RED_HIGH    (31 << 11)

#define LED_GREEN_VERYLOW (1 <<  5)   
#define LED_GREEN_LOW     (15 << 5)  
#define LED_GREEN_MEDIUM  (31 << 5)  
#define LED_GREEN_HIGH    (63 << 5)  

#define LED_BLUE_VERYLOW  3
#define LED_BLUE_LOW    7
#define LED_BLUE_MEDIUM   15
#define LED_BLUE_HIGH     31

#define LED_ORANGE_VERYLOW  (LED_RED_VERYLOW + LED_GREEN_VERYLOW)
#define LED_ORANGE_LOW    (LED_RED_LOW     + LED_GREEN_LOW)
#define LED_ORANGE_MEDIUM (LED_RED_MEDIUM  + LED_GREEN_MEDIUM)
#define LED_ORANGE_HIGH   (LED_RED_HIGH    + LED_GREEN_HIGH)

#define LED_PURPLE_VERYLOW  (LED_RED_VERYLOW + LED_BLUE_VERYLOW)
#define LED_PURPLE_LOW    (LED_RED_LOW     + LED_BLUE_LOW)
#define LED_PURPLE_MEDIUM (LED_RED_MEDIUM  + LED_BLUE_MEDIUM)
#define LED_PURPLE_HIGH   (LED_RED_HIGH    + LED_BLUE_HIGH)

#define LED_CYAN_VERYLOW  (LED_GREEN_VERYLOW + LED_BLUE_VERYLOW)
#define LED_CYAN_LOW    (LED_GREEN_LOW     + LED_BLUE_LOW)
#define LED_CYAN_MEDIUM   (LED_GREEN_MEDIUM  + LED_BLUE_MEDIUM)
#define LED_CYAN_HIGH   (LED_GREEN_HIGH    + LED_BLUE_HIGH)

#define LED_WHITE_VERYLOW (LED_RED_VERYLOW + LED_GREEN_VERYLOW + LED_BLUE_VERYLOW)
#define LED_WHITE_LOW   (LED_RED_LOW     + LED_GREEN_LOW     + LED_BLUE_LOW)
#define LED_WHITE_MEDIUM  (LED_RED_MEDIUM  + LED_GREEN_MEDIUM  + LED_BLUE_MEDIUM)
#define LED_WHITE_HIGH    (LED_RED_HIGH    + LED_GREEN_HIGH    + LED_BLUE_HIGH)
// MATRIX DECLARATION:
// Parameter 1 = width of NeoPixel matrix
// Parameter 2 = height of matrix
// Parameter 3 = pin number (most are valid)
// Parameter 4 = matrix layout flags, add together as needed:
//   NEO_MATRIX_TOP, NEO_MATRIX_BOTTOM, NEO_MATRIX_LEFT, NEO_MATRIX_RIGHT:
//     Position of the FIRST LED in the matrix; pick two, e.g.
//     NEO_MATRIX_TOP + NEO_MATRIX_LEFT for the top-left corner.
//   NEO_MATRIX_ROWS, NEO_MATRIX_COLUMNS: LEDs are arranged in horizontal
//     rows or in vertical columns, respectively; pick one or the other.
//   NEO_MATRIX_PROGRESSIVE, NEO_MATRIX_ZIGZAG: all rows/columns proceed
//     in the same order, or alternate lines reverse direction; pick one.
//   See example below for these values in action.
// Parameter 5 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_GRBW    Pixels are wired for GRBW bitstream (RGB+W NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)


// Example for NeoPixel Shield.  In this application we'd like to use it
// as a 5x8 tall matrix, with the USB port positioned at the top of the
// Arduino.  When held that way, the first pixel is at the top right, and
// lines are arranged in columns, progressive order.  The shield uses
// 800 KHz (v2) pixels that expect GRB color data.



 Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(8, 8, 1, 2, PIN, 
  NEO_MATRIX_TOP     + NEO_MATRIX_LEFT +
  NEO_MATRIX_COLUMNS + NEO_MATRIX_ZIGZAG +
  NEO_TILE_TOP + NEO_TILE_LEFT +
  NEO_TILE_COLUMNS + NEO_TILE_ZIGZAG,
  NEO_GRB            + NEO_KHZ800); 

const uint16_t colors[] = {
  matrix.Color(0, 0, 0),      // 0 = Black
  matrix.Color(255, 0, 0),    // 1 = Red
  matrix.Color(0, 255, 0),    // 2 = Lime
  matrix.Color(0, 0, 255),    // 3 = Blue
  matrix.Color(255, 165, 0),  // 4 = Orange
  matrix.Color(255, 255, 0),  // 5 = Yellow
  matrix.Color(128, 0, 0),    // 6 = Maroon
  matrix.Color(128, 0, 128),  // 7 = Purple
  matrix.Color(255, 0, 255),  // 8 = Fuchsia
  matrix.Color(0, 128, 0),    // 9 = Green
  matrix.Color(128, 128, 0),  // 10 = Olive
  matrix.Color(0, 0, 128),    // 11 = Navy
  matrix.Color(0, 128, 128),  // 12 = Teal
  matrix.Color(0, 255, 255),  // 13 = Aqua
  matrix.Color(128, 128, 128),// 14 = Gray
  matrix.Color(192, 192, 192),// 15 = Silver
  matrix.Color(255, 255, 255),  // 16 = White
  };

int color1;
String text1;
int c1;
int c2;
int x1;
int y;
int ax;
int ay;
int eye;
bool ok;
bool finish_q;
unsigned long finish_elapsed, finish_count;

unsigned long t1;
unsigned long t2;

void setup() {
  WiFi.mode(WIFI_OFF);
  matrix.begin();
  matrix.setTextWrap(false);
  matrix.setTextSize(1);
  
  //matrix.setFont(&muHeavy8ptBold);
  matrix.setBrightness(10);
  matrix.fillScreen(0);
 x1 = 7;
 y = 0;
 ax = 0;
 ay = 12;
 //c1 = random (1, 17);
 //c2 = random (1, 17);
 ok = true;
}


void loop() {


//Hallowen text

      if (millis() - t1 >= 50) 
           {
            matrix.drawPixel(x1, y, colors[9]);
            matrix.show();
            x1--;
            if (x1<0) {
                x1=7;
                if (y<11) {y++;}
                }
            if ((x1==0) && (y==11)) {ok = false; }
            t1 += 50;
            }
      
      //pumpkin eyes
      
      if (millis() - t2 >= 20) 
           {
            for (ax = 0; ax <= 7; ax++) {
                for ( ay = 12; ay <= 15; ay++) {
                  eye = random (0, 2);
                  if (eye==0) {matrix.drawPixel(ax, ay, colors[1]); }
                  else  {matrix.drawPixel(ax, ay, colors[0]); }                                 
                }
            }
            ax = 0;
            ay = 12;
            t2 += 20;  
         }

    finish_q = TON (!ok, 2000, finish_elapsed, finish_count);

  if (finish_q) {
    matrix.fillScreen(0);
    matrix.show();
    //ESP.deepSleep(0);
    delay (5000);
    ESP.restart();
  } 
    
}
